import { Point } from "./Utilities";
interface DetectProps {
    detectElement: HTMLImageElement | HTMLCanvasElement;
    scanElement?: HTMLCanvasElement;
    resultElement: HTMLCanvasElement;
    drawRectangle?: boolean;
    showContours?: boolean;
    contourColor?: {
        r: number;
        g: number;
        b: number;
    };
}
export declare const detect: ({ detectElement, showContours, drawRectangle, scanElement, resultElement, contourColor }: DetectProps) => void;
interface DetectVideoProps {
    videoDisplayElement: HTMLVideoElement;
    resultElement?: HTMLCanvasElement;
    drawRectangle?: boolean;
    showContours?: boolean;
    fps?: number;
    contourColor?: {
        r: number;
        g: number;
        b: number;
    };
    onDetect?: (rectanglePoints: Point[]) => void;
}
interface DetectVideoReturnProps {
    stop: () => void;
}
export declare const detectVideo: ({ videoDisplayElement, showContours, drawRectangle, resultElement, onDetect, fps, contourColor, }: DetectVideoProps) => Promise<DetectVideoReturnProps>;
export {};
